﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ExtremeDataSummarizer
{
    class Program
    {
        static void Main(string[] args)
        {
            int numLevels = 15;
            using (var fr = new FileStream("d:/tmp/largeData/largeData.txt", FileMode.Open))
            {
                using (var br = new BinaryReader(fr))
                {
                    long currCount = fr.Length / 16;
                    long totalCount = currCount;
                    long currBucketSize = 1;
                    Debug.WriteLine(currCount);

                    for (var currLevel = 0; currLevel < numLevels; currLevel++)
                    {
                        Debug.WriteLine(currCount);
                        br.BaseStream.Seek(0, SeekOrigin.Begin);

                        long previousBucket = 0;

                        using (FileStream os = new FileStream("d:/tmp/largeData/largeData-" + currLevel + ".txt", FileMode.Create))
                        {

                            using (BinaryWriter bw = new BinaryWriter(os))
                            {
                                DateTime currBucketTime = DateTime.MinValue;
                                double currBucketMin = double.MaxValue;
                                double currBucketMax = double.MinValue;

                                while (br.BaseStream.Position < br.BaseStream.Length)
                                {
                                    long currentBucket = (long)Math.Floor(((double)br.BaseStream.Position / 16) / currBucketSize);
                                    if (currentBucket != previousBucket)
                                    {
                                        previousBucket = currentBucket;

                                        bw.Write(currBucketTime.ToBinary());
                                        bw.Write(currBucketMin);
                                        bw.Write(currBucketMax);

                                        currBucketTime = DateTime.MinValue;
                                        currBucketMin = double.MaxValue;
                                        currBucketMax = double.MinValue;
                                    }
                                    long time = br.ReadInt64();
                                    double value = br.ReadDouble();

                                    if (currBucketTime == DateTime.MinValue)
                                    {
                                        currBucketTime = DateTime.FromBinary(time);
                                        currBucketMin = value;
                                        currBucketMax = value;
                                    }

                                    currBucketMin = Math.Min(currBucketMin, value);
                                    currBucketMax = Math.Max(currBucketMax, value);
                                }

                            }
                        }

                        currCount = (long)Math.Round(currCount / 2.0);
                        currBucketSize = (long)Math.Floor((double)totalCount / currCount);
                    }
                }
            }
        }
    }
}
